;   16 
;   
;






.include 	"tn2313adef.inc"	;  tiny2313a


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;    SREG
.def	Temp5=R21
.def	Temp6=R22			; 
.def	Temp7=R23			; 
.def	Temp8=R24
.def	Temp9=R25










;******************************************************************************
; 
;******************************************************************************



.dseg					; 



ch_count: .byte 1			;   // 0,1,2 
					;  = 3,   
					;  = 4,       


THR_len: .byte 2			;  2    =     ""


ruds_len: .byte 2			;  2    =     "ruds"













;******************************************************************************
; 
;******************************************************************************



.equ	MIDDLE_RUD_const = 0x200	; 512 =    (   )



.EQU	const_1000 = 0x3E8 		; 1000  



.EQU	Chastota_const=0x9C40 		;     (  50  )
					; 50=0,02
					; 1   = 0,0000005 
					; 0,02/0,0000005=40000 ( 0x9C40 )













;******************************************************************************
;   
;******************************************************************************

.cseg

			

.org 0

rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset






.org ICP1addr				; = 0x0003 Timer/Counter1 Capture Event (  ICP )

rjmp ICP1_interruption




.org INT_VECTORS_SIZE











;******************************************************************************
;  ***********************************************************************
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;



	
	ldi Temp,0b11111111		;   "" (0-, 1-)
	out DDRB,Temp			; 
					 
		
	ldi Temp,0b00000000		;  _0
	out PortB,Temp			; 



		
												 
	ldi Temp,0b00111111		;   "D" (0-, 1-)
	out DDRD,Temp 			; 00xxxxxx -    
					; 0000000 -    (ICP)



	ldi Temp,0b00000000		;  _0
	out PortD,Temp			;



;	RCALL	LCD_INIT		;  




;******************************************************************************
;   _1
;******************************************************************************



;    (  )
; ICP    .


					

	ldi Temp,(1<<COM1A1)|(1<<COM1B1)|(1<<WGM11)|(1<<WGM10)
	out TCCR1A,Temp	
				
					;      OCR1A //   ,   
					; *1 (     )
					;   OC1A    !    !


					; COM1A1  /   OC1A // 
					; COM1A0  /   OC1A // 
					; COM1B1  /   OC1B // 
					; COM1B0  /   OC1B //  
					; WGM11=1 /  *
					; WGM10=0 /  *





	ldi Temp,(0<<ICES1)|(1<<WGM13)|(1<<WGM12)|(1<<cs11)	
	out TCCR1B,Temp					
					;    ICP   							;*****
					;    1/8 ( 1   = 0,5  )
					; *1



					;   = CK 1:8 (16/8=2) 1   = 0,5 
					;   !!!

					; ICNC1=0 /     ICP // 
					; ICES1=0 /    ICP   
					; WGM13=1 /  *
					; WGM12=1 /  *   ( Fast PWM )
					; CS12=0  /  
					; CS11=1  /   
					; CS10=0  /   = CK 1:8 (16/8=2) 1   = 0,5 




	LDI Temp,high(Chastota_const)	;    (    )
	OUT OCR1AH,Temp			;      
	LDI Temp,low(Chastota_const)							
	OUT OCR1AL,Temp	



	ldi xh, 0xB			; 3000 = 0x0BB8 -   ...
	ldi xl, 0xB8


	OUT OCR1BH,XH			;    (   )
	OUT OCR1BL,XL			;      




;******************************************************************************
;  
;******************************************************************************


	ldi Temp, 4			;   /_
	sts ch_count, Temp







;******************************************************************************
;  
;******************************************************************************



	ldi Temp,0			;  _1
	out TCNT1H,Temp
	out TCNT1L,Temp

	sei				;   




	

;*******************************************************************************
;   *****************************************************************
;*******************************************************************************


Main_cicle:


	
	rjmp Main_cicle			; 






;*******************************************************************************
;   *********************************************************
;*******************************************************************************

ICP1_interruption:
	



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4



	in XL,ICR1L 			;    
	in XH,ICR1H 			;    



	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp







	ldi zh, 0xF			; 4000 = 0x0FA0 -    ...
	ldi zl, 0xA0


	OUT OCR1BH,zH			;    (   )
	OUT OCR1BL,zL			;      







;**************************************************************************************************************
;   (  -     )
;**************************************************************************************************************



	LDS Temp, ch_count		;   


	cpi Temp, 4			;    ?
	brne work			;  ,  !!!!
	rjmp sinhro			;  ,  





;*********************************************************************************
;     13  ( 0b110010110010000 ) ( 0x6590 )
;*********************************************************************************

sinhro:

	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0x65			;     "Y" 13  0x6590
	ldi YL,0x90



	rcall compare_XY16		; ...

	breq bolshe			;     X=Y 
	brcs menshe			;     X<Y
	rjmp bolshe			;     X>Y 






;*****************************************************************************************
;   
;*****************************************************************************************


compare_XY16:

	cp Temp,YH			;    
	breq xh_eq_yh			;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret                            






;*****************************************************************************************
; ...
;*****************************************************************************************




bolshe:					;  ! 


	ldi Temp, 0			;   _,   0-  
	sts ch_count, Temp

	rjmp out_1			; 






menshe:					;    !

	rjmp out_1			; 







;*****************************************************************************************
;  ,  
;*****************************************************************************************


work:						;



channal_check_0:				;  _0


	LDS Temp, ch_count			;   


	cpi Temp, 0				;  0-  ?
	brne channal_check_1			; 
	rjmp channal_0				; 






channal_check_1:				;  _1


	LDS Temp, ch_count			;   


	cpi Temp, 1				;  1-  ?
	brne channal_check_2			; 
	rjmp channal_1				; 




channal_check_2:				;  _2


	LDS Temp, ch_count			;   


	cpi Temp, 2				;  2-  ?
	brne channal_check_sinhro		; 
	rjmp channal_2				; 





channal_check_sinhro:				;  (    ,  -  )			



	ldi Temp, 4				;  ,   
	sts ch_count, Temp


	rjmp sinhro







;*****************************************************************************************
;   
;*****************************************************************************************




channal_0:					; _0 (  )

	
	ldi Temp, 1				;   _1
	sts ch_count, Temp




	rjmp out_1				; 									








;**********************************************************************************************



channal_1:					; _1 (  )




	ldi Temp, 2				;   _2
	sts ch_count, Temp




	rjmp out_1				; 







;**********************************************************************************************

channal_2:					; _2 (   )





	ldi Temp, 3				;   
	sts ch_count, Temp





						 
	OUT OCR1BH,XH				;   
	OUT OCR1BL,XL				;      




	rjmp out_1				; 









;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    



;**************************************************************************************************************
;  
;**************************************************************************************************************

; .include "lcd5110mini.asm"		;   	




